package dni3toOmnetTransformation;

import OMNET.NedFile;
import OMNET.OMNETPackage;
import OMNET.OmnetppIniFile;
import OMNET.RoutingXmlFile;
import com.google.common.collect.Iterables;
import dnimm3.Common;
import dnimm3.Dnimm3Package;
import dnimm3.IType;
import dnimm3.NamedElement;
import dnimm3.NetworkInfrastructure;
import dnimm3.NetworkStructure;
import dnimm3.Node;
import java.io.FileOutputStream;
import java.util.Map;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceImpl;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.InputOutput;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;
import org.eclipse.xtext.xbase.lib.ObjectExtensions;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;

@SuppressWarnings("all")
public class Main {
  private final static String NAME = "dni3toomnet";
  
  public static void main(final String[] args) {
    String fname = "minimal.dnimm3";
    int _length = args.length;
    boolean _lessThan = (_length < 1);
    if (_lessThan) {
      InputOutput.<String>println((Main.NAME + " expects a filename as its first input, see --help for more information. Continuing with default file minimal.dnimm3"));
    } else {
      String _get = args[0];
      boolean _equals = _get.equals("--help");
      if (_equals) {
        InputOutput.<String>print("TODO Help");
        return;
      } else {
        String _get_1 = args[0];
        fname = _get_1;
      }
    }
    final URI dnimm3Uri = URI.createFileURI(fname);
    final URI omnetUri = URI.createFileURI("omnet_base.omnetmodel");
    final ResourceSetImpl resourceSet = new ResourceSetImpl();
    final EPackage.Registry packageRegistry = resourceSet.getPackageRegistry();
    packageRegistry.put(OMNETPackage.eNS_URI, OMNETPackage.eINSTANCE);
    packageRegistry.put(Dnimm3Package.eNS_URI, Dnimm3Package.eINSTANCE);
    final Map<String, Object> extensionFactoryMap = Resource.Factory.Registry.INSTANCE.getExtensionToFactoryMap();
    XMIResourceFactoryImpl _xMIResourceFactoryImpl = new XMIResourceFactoryImpl();
    extensionFactoryMap.put("dnimm3", _xMIResourceFactoryImpl);
    XMIResourceFactoryImpl _xMIResourceFactoryImpl_1 = new XMIResourceFactoryImpl();
    extensionFactoryMap.put("omnetmodel", _xMIResourceFactoryImpl_1);
    final Resource dniResource = resourceSet.getResource(dnimm3Uri, true);
    final Resource omnetResource = resourceSet.getResource(omnetUri, true);
    Main.do_transformation(dniResource, omnetResource);
    XMIResourceImpl _xMIResourceImpl = new XMIResourceImpl();
    final Procedure1<XMIResourceImpl> _function = new Procedure1<XMIResourceImpl>() {
      @Override
      public void apply(final XMIResourceImpl it) {
        try {
          EList<EObject> _contents = it.getContents();
          EList<EObject> _contents_1 = omnetResource.getContents();
          EObject _get = _contents_1.get(0);
          _contents.add(_get);
          FileOutputStream _fileOutputStream = new FileOutputStream("./output_omnet.xmi");
          it.save(_fileOutputStream, null);
        } catch (Throwable _e) {
          throw Exceptions.sneakyThrow(_e);
        }
      }
    };
    ObjectExtensions.<XMIResourceImpl>operator_doubleArrow(_xMIResourceImpl, _function);
  }
  
  private static String do_transformation(final Resource dniResource, final Resource omnetResource) {
    String _xblockexpression = null;
    {
      EList<EObject> _contents = dniResource.getContents();
      EObject _get = _contents.get(0);
      final NetworkInfrastructure dniModel = ((NetworkInfrastructure) _get);
      EList<EObject> _contents_1 = omnetResource.getContents();
      EObject _get_1 = _contents_1.get(0);
      final NedFile omnetModel = ((NedFile) _get_1);
      InputOutput.<String>println("== Starting transformation ==");
      final NetworkInfrastructure dni = dniModel;
      final NedFile ned = omnetModel;
      final OmnetppIniFile ini = omnetModel.getConfig();
      OmnetppIniFile _config = omnetModel.getConfig();
      final RoutingXmlFile routingxml = _config.getRoutingconf();
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("example_");
      String _dataCenterName = dni.getDataCenterName();
      _builder.append(_dataCenterName, "");
      _builder.append(".xml");
      routingxml.setFilename(_builder.toString());
      String _dataCenterName_1 = dni.getDataCenterName();
      String _plus = ("example_" + _dataCenterName_1);
      String _plus_1 = (_plus + ".xml");
      routingxml.setFilename(_plus_1);
      TreeIterator<EObject> _allContents = dniResource.getAllContents();
      Iterable<EObject> _iterable = IteratorExtensions.<EObject>toIterable(_allContents);
      for (final EObject e : _iterable) {
        InputOutput.<EObject>println(e);
      }
      TreeIterator<EObject> _allContents_1 = dniResource.getAllContents();
      Iterable<EObject> _iterable_1 = IteratorExtensions.<EObject>toIterable(_allContents_1);
      Iterable<NamedElement> _filter = Iterables.<NamedElement>filter(_iterable_1, NamedElement.class);
      for (final NamedElement e_1 : _filter) {
        String _name = e_1.getName();
        InputOutput.<String>println(_name);
      }
      NetworkStructure _structure = dni.getStructure();
      EList<Node> _nodes = _structure.getNodes();
      final Function1<Node, Boolean> _function = new Function1<Node, Boolean>() {
        @Override
        public Boolean apply(final Node it) {
          IType _sdntype = it.getSdntype();
          return Boolean.valueOf((_sdntype instanceof Common));
        }
      };
      Iterable<Node> _filter_1 = IterableExtensions.<Node>filter(_nodes, _function);
      final Function1<Node, Node> _function_1 = new Function1<Node, Node>() {
        @Override
        public Node apply(final Node it) {
          return ((Node) it);
        }
      };
      final Iterable<Node> dniCommonNodes = IterableExtensions.<Node, Node>map(_filter_1, _function_1);
      for (final Node n : dniCommonNodes) {
        InputOutput.<Node>println(n);
      }
      _xblockexpression = InputOutput.<String>println("== Transformation finished ==");
    }
    return _xblockexpression;
  }
}
