package epsilonStandalone

import epsilonStandalone.DNIRunner
import org.eclipse.epsilon.eol.execute.context.Variable
import org.eclipse.epsilon.eol.types.EolPrimitiveType
import java.util.List

class DNIRunner_mk extends DNIRunner {
	
	public def static void main(String[] args) {
	  	
	  	val a = new DNIRunner_mk()
	  	a.reset()
//	  	a.start_experiment1(true)
	  	a.model_generation_1A(false)
		  	
  	}
  	
  	public def reset(){
  		simQpnParser.interestingPlaces = newLinkedList("SW35_i_SW01_rx")//, "SW_SDN_Switching_QP_SwitchSDN(HP3500)", "HW_SDN_Switching_QP_SwitchSDN(HP3500)")
  		simQpnParser.interestingColors = newLinkedList("Traffic_")
  		simQpnParser.interestingMetrics = newLinkedList("arrivThrPut")//, "deptThrPut")
  		
  		dniModels.clear
		qpmeModels.clear
		qpmeFiles.clear
		qpmeSimulationResultFiles.clear
		qpmeSimulationProcessedResults.clear
  		
  		dni_base_model_file = "models/scenario1A_01.model"
  		
  		
  	}
  	
	public def model_generation_1A(boolean simulate){
		
		simQpnParser.interestingPlaces = newLinkedList("SW35_i_SW01_rx")//, "SW_SDN_Switching_QP_SwitchSDN(HP3500)", "HW_SDN_Switching_QP_SwitchSDN(HP3500)")
  		simQpnParser.interestingColors = newLinkedList("Traffic_send")
  		simQpnParser.interestingMetrics = newLinkedList("arrivThrPut")//, "deptThrPut")
		
		var String finalResult = ""
		var expNamePrefix = "Experiment-1A"
		
		dni_base_model_file = "models/scenario1A_01.model"
		
		var i=0
		for(param_num_clients_1A: #[1,5,10,15,20,25,30,35]){
			var String expName = expNamePrefix+".clients."+param_num_clients_1A+".zzz";
			
			// these parameter will be passed to eol script
			var List<Variable> list = newLinkedList()
			list.add(new Variable("param_num_clients_1A", param_num_clients_1A, EolPrimitiveType.Integer))
			epsilonTransformationParameters.put(expName, list)
			
			//create a model that is a copy of dni_base_model_file and apply the eol script on the copy
			var ExperimentModel pairExpNameDniModel = stateless_applyEolStriptToBaseModel(dni_base_model_file, "eol/scenario1_auto_gen.eol", list, i, expName);
			dniModels.add(pairExpNameDniModel)
			
			i=i+1	
		}
		
		// now you have ready DNI models in the list 'dniModels'
		
		checkDniModels		// eol //optional
		
		for(dniURI : dniModels){
			
			var experimentName = (dniURI as ExperimentModel).experiment
			var modelURI = (dniURI as ExperimentModel).modelURI
			
			//var qpmeResultURI = transformDniToQpn(modelURI, experimentName)
			
			var List<Variable> origParameterList = epsilonTransformationParameters.get(experimentName)
			var outFileName = experimentName+".qpmemodel"
			var destinationModelURI = pwdURI+qpmeModelsDirRelative+outFileName
			
			// make suer to update the transformation "etl/standalone-DNI-QPN.etl" to the newest version!!
			var qpmeResultURI = stateless_applyEtlStript("DNI", modelURI, "models/dnimm3.ecore", 
													"QPME", destinationModelURI, "models/qpme.ecore",
													"etl/standalone-DNI-QPN.etl", origParameterList, experimentName)
			qpmeModels.add(new ExperimentModel(experimentName, qpmeResultURI))
		}
		// now you have ready QPN models in the list 'qpmeModels'
		generateQpeFiles
		
//		
//		transformAll		// etl
//		//qpmeModels is filled
//		generateQpeFiles	//egl


		cleanup
	}
	
	
	public def start_experiment1(boolean simulate){
		
		var String finalResult = ""
		
		var models = newLinkedList(/*new ExperimentModel("scenario0A", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/scenario0A.results.xml"),
								   new ExperimentModel("scenario0B_1", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/scenario0B_1.results.xml"),
								   new ExperimentModel("scenario0B_2", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/scenario0B_2.results.xml"),
								   new ExperimentModel("scenario0B_3", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/scenario0B_3.results.xml"),
								   new ExperimentModel("scenario0B_4a", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/scenario0B_4a.results.xml"),
								   new ExperimentModel("scenario0B_4b", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/scenario0B_4b.results.xml"),*/
								   //new ExperimentModel("scenario1A_C39_request_from_C10_25", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/scenario1A_C39_request_from_C10_25.results.xml")
								   new ExperimentModel("scenario1B_C39_request_from_C10_01_hw", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/scenario1B_C39_request_from_C10_01_hw.results.xml")
		)						
		
		for (m : models) {
			var experimentName = (m as ExperimentModel).experiment
			var String result = parseResult((m as ExperimentModel).modelURI, experimentName)
			var String line = experimentName+" # "+result
			finalResult += line
			println(line)
			qpmeSimulationProcessedResults.add(result) 
					
			saveOutput(finalResult, "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/"+experimentName+".final")
		}	

		cleanup
	}
}